﻿Start-Transcript -Path C:\DEMO\warmupNAV\output.log

. 'C:\Program Files\Microsoft Dynamics NAV\80\Service\NavAdminTool.ps1'

Get-NAVServerSession -ServerInstance NAV | % { Remove-NAVServerSession -ServerInstance NAV -SessionId $_.SessionID -Force }

CD C:\demo\WarmupNAV

$CustomSettingsConfigFile = 'c:\program files\Microsoft Dynamics NAV\80\Service\CustomSettings.config'
$config = [xml](Get-Content $CustomSettingsConfigFile)
$publicWebBaseUrl = $config.SelectSingleNode("//appSettings/add[@key='PublicWebBaseUrl']").value
$serverInstance = $config.SelectSingleNode("//appSettings/add[@key='ServerInstance']").value
$multitenant = $config.SelectSingleNode("//appSettings/add[@key='Multitenant']").value
$tenantQstr = ''
$tenant = (Get-NAVTenant $serverInstance | Select-Object -First 1).Id

if ($multitenant -eq 'true') {
    $tenantQstr = ("?tenant="+$tenant)
}

if (!($publicWebBaseUrl)) {
    # Windows Authentication and localhost
    & .\WarmupNAV.exe "http://localhost:8080/$ServerInstance/WebClient$tenantQstr"
    $ERR = $LASTEXITCODE
} else {
    $WarmupUsername = "warmupuser"
    $WarmupPassword = "wrmupP@ssw0rd"

    if (!(Get-NAVServerUser -ServerInstance $serverInstance -Tenant $tenant | Where-Object { $_.UserName -eq $WarmupUsername })) {
        New-NAVServerUser -ServerInstance $serverInstance  -Tenant $tenant -UserName $WarmupUsername -Password (ConvertTo-SecureString -String $WarmupPassword -AsPlainText -Force) 
        New-NAVServerUserPermissionSet -ServerInstance $serverInstance -Tenant $tenant -UserName $WarmupUsername -PermissionSetId SUPER
    } else {
        Set-NAVServerUser -ServerInstance $serverInstance -Tenant $tenant -UserName $WarmupUsername -State Enabled
    }
    & .\WarmupNAV.exe "$publicWebBaseUrl$tenantQstr" $WarmupUsername $WarmupPassword
    $ERR = $LASTEXITCODE
    Set-NAVServerUser -ServerInstance $serverInstance -Tenant $tenant -UserName $WarmupUsername -State Disabled
}

Get-NAVServerSession -ServerInstance $serverInstance -Tenant $tenant | % { Remove-NAVServerSession -ServerInstance $serverInstance -Tenant $tenant -SessionId $_.SessionID -Force }

if ($ERR) {
    Write-Host -ForegroundColor Red "Warmup failed"
} else {
    Write-Host -ForegroundColor Green "Warmup succeeded"
}