﻿$PSScriptRootV2 = Split-Path $MyInvocation.MyCommand.Definition -Parent 
Set-StrictMode -Version 2.0
$verbosePreference = 'Continue'
$errorActionPreference = 'Inquire'

$HardcodeFile = (Join-Path $PSScriptRootV2 'HardcodeInput.ps1')
if (Test-Path -Path $HardcodeFile) {
    . $HardcodeFile
}

if (!(Get-ScheduledTask -TaskName "Warmup Task" -ErrorAction SilentlyContinue)) {
    $HardcodeFile = (Join-Path $PSScriptRootV2 'HardcodeInput.ps1')
    if (Test-Path -Path $HardcodeFile) {
        . $HardcodeFile
    }
    . (Join-Path $PSScriptRootV2 'HelperFunctions.ps1')
    
    $VMAdminUsername = Get-UserInput -Id VMAdminUsername -Text "VM administrator username" -Default $env:USERNAME
    $VMAdminPassword = Get-Variable -name "HardcodeVMAdminPassword" -ValueOnly -ErrorAction SilentlyContinue
    if (!($VMAdminPassword)) {
        $VMAdminSecurePassword = Read-Host "VM administrator password" -AsSecureString
        $VMAdminPassword = Decrypt-SecureString $VMAdminSecurePassword
    }

    Register-ScheduledTask -Xml (get-content 'C:\DEMO\WarmupNAV\WarmupNAV.xml' | out-string) -TaskName "Warmup Task" -User $VMAdminUserName -Password $VMAdminPassword –Force
}
